---
title: llarp/layers/flow/flow_identity.hpp

---

# llarp/layers/flow/flow_identity.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::layers](Namespaces/namespacellarp_1_1layers.md)**  |
| **[llarp::layers::flow](Namespaces/namespacellarp_1_1layers_1_1flow.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| struct | **[llarp::layers::flow::FlowIdentityPrivateKeys](Classes/structllarp_1_1layers_1_1flow_1_1FlowIdentityPrivateKeys.md)**  |
| class | **[llarp::layers::flow::FlowIdentity](Classes/classllarp_1_1layers_1_1flow_1_1FlowIdentity.md)** <br>local flow  |




## Source code

```cpp
#pragma once

#include <llarp/crypto/types.hpp>

#include "flow_addr.hpp"
#include "flow_info.hpp"

namespace llarp::layers::flow
{

  struct FlowIdentityPrivateKeys
  {
    SecretKey identity;
    SecretKey encryption;
    PrivateKey derivedKey;
    PQKeyPair sntrup;

    static FlowIdentityPrivateKeys
    keygen();
  };

  class FlowIdentity
  {
    FlowIdentityPrivateKeys _keys;

   public:
    void
    async_obtain_flow_to(
        flow::FlowAddr to,
        std::string authcode,
        std::function<void(std::optional<FlowInfo>, std::string)> result_handler);
  };
}  // namespace llarp::layers::flow
```


-------------------------------

Updated on 2023-01-27 at 20:09:05 +0000
